//
// Copyright (c) 2011, 2013, Oracle and/or its affiliates. All rights reserved.
// Copyright 2012, 2013 SAP AG. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//
//
// Copyright (c) 2011, 2014, Oracle and/or its affiliates. All rights reserved.
// Copyright 2012, 2014 SAP AG. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_ppc_64.hpp"
#include "opto/cfgnode.hpp"
#include "opto/locknode.hpp"


//------------------------- MachOper Generator ---------------
// A switch statement on the dense-packed user-defined type system
// that invokes 'new' on the corresponding class constructor.

MachOper *State::MachOperGenerator(int opcode, Compile* C){

  switch(opcode) {
  case UNIVERSE:
    return new (C) UniverseOper( );
  case LABEL:
    return new (C) labelOper( );
  case SREGI:
    return new (C) sRegIOper( );
  case SREGP:
    return new (C) sRegPOper( );
  case SREGF:
    return new (C) sRegFOper( );
  case SREGD:
    return new (C) sRegDOper( );
  case SREGL:
    return new (C) sRegLOper( );
  case METHOD:
    return new (C) methodOper( );
  case IMMI:
    return new (C) immIOper(_leaf->get_int() );
  case IMMI8:
    return new (C) immI8Oper(_leaf->get_int() );
  case IMMI16:
    return new (C) immI16Oper(_leaf->get_int() );
  case IMMIHI16:
    return new (C) immIhi16Oper(_leaf->get_int() );
  case IMMINEGPOW2:
    return new (C) immInegpow2Oper(_leaf->get_int() );
  case IMMIPOW2MINUS1:
    return new (C) immIpow2minus1Oper(_leaf->get_int() );
  case IMMIPOWEROF2:
    return new (C) immIpowerOf2Oper(_leaf->get_int() );
  case UIMMI5:
    return new (C) uimmI5Oper(_leaf->get_int() );
  case UIMMI6:
    return new (C) uimmI6Oper(_leaf->get_int() );
  case UIMMI6_GE32:
    return new (C) uimmI6_ge32Oper(_leaf->get_int() );
  case UIMMI15:
    return new (C) uimmI15Oper(_leaf->get_int() );
  case UIMMI16:
    return new (C) uimmI16Oper(_leaf->get_int() );
  case IMMI_0:
    return new (C) immI_0Oper(_leaf->get_int() );
  case IMMI_1:
    return new (C) immI_1Oper(_leaf->get_int() );
  case IMMI_MINUS1:
    return new (C) immI_minus1Oper(_leaf->get_int() );
  case IMMI_16:
    return new (C) immI_16Oper(_leaf->get_int() );
  case IMMI_24:
    return new (C) immI_24Oper(_leaf->get_int() );
  case IMMN:
    return new (C) immNOper(_leaf->bottom_type()->is_narrowoop() );
  case IMMN_0:
    return new (C) immN_0Oper(_leaf->bottom_type()->is_narrowoop() );
  case IMMNKLASS:
    return new (C) immNKlassOper(_leaf->bottom_type()->is_narrowklass() );
  case IMMNKLASS_NM:
    return new (C) immNKlass_NMOper(_leaf->bottom_type()->is_narrowklass() );
  case IMMP:
    return new (C) immPOper(_leaf->bottom_type()->is_ptr() );
  case IMMP_NM:
    return new (C) immP_NMOper(_leaf->bottom_type()->is_ptr() );
  case IMMP_0:
    return new (C) immP_0Oper(_leaf->bottom_type()->is_ptr() );
  case IMMP_0OR1:
    return new (C) immP_0or1Oper(_leaf->bottom_type()->is_ptr() );
  case IMML:
    return new (C) immLOper(_leaf->get_long() );
  case IMML16:
    return new (C) immL16Oper(_leaf->get_long() );
  case IMML16ALG4:
    return new (C) immL16Alg4Oper(_leaf->get_long() );
  case IMML32HI16:
    return new (C) immL32hi16Oper(_leaf->get_long() );
  case IMML32:
    return new (C) immL32Oper(_leaf->get_long() );
  case IMMLHIGHEST16:
    return new (C) immLhighest16Oper(_leaf->get_long() );
  case IMMLNEGPOW2:
    return new (C) immLnegpow2Oper(_leaf->get_long() );
  case IMMLPOW2MINUS1:
    return new (C) immLpow2minus1Oper(_leaf->get_long() );
  case IMML_0:
    return new (C) immL_0Oper(_leaf->get_long() );
  case IMML_MINUS1:
    return new (C) immL_minus1Oper(_leaf->get_long() );
  case IMML_32BITS:
    return new (C) immL_32bitsOper(_leaf->get_long() );
  case UIMML16:
    return new (C) uimmL16Oper(_leaf->get_long() );
  case IMMF:
    return new (C) immFOper(_leaf->getf() );
  case IMMF_0:
    return new (C) immF_0Oper(_leaf->getf() );
  case IMMD:
    return new (C) immDOper(_leaf->getd() );
  case IREGIDST:
    return new (C) iRegIdstOper( );
  case IREGISRC:
    return new (C) iRegIsrcOper( );
  case RSCRATCH1REGI:
    return new (C) rscratch1RegIOper( );
  case RSCRATCH2REGI:
    return new (C) rscratch2RegIOper( );
  case RARG1REGI:
    return new (C) rarg1RegIOper( );
  case RARG2REGI:
    return new (C) rarg2RegIOper( );
  case RARG3REGI:
    return new (C) rarg3RegIOper( );
  case RARG4REGI:
    return new (C) rarg4RegIOper( );
  case RARG1REGL:
    return new (C) rarg1RegLOper( );
  case RARG2REGL:
    return new (C) rarg2RegLOper( );
  case RARG3REGL:
    return new (C) rarg3RegLOper( );
  case RARG4REGL:
    return new (C) rarg4RegLOper( );
  case IREGPDST:
    return new (C) iRegPdstOper( );
  case IREGPDSTNOSCRATCH:
    return new (C) iRegPdstNoScratchOper( );
  case IREGPSRC:
    return new (C) iRegPsrcOper( );
  case THREADREGP:
    return new (C) threadRegPOper( );
  case RSCRATCH1REGP:
    return new (C) rscratch1RegPOper( );
  case RSCRATCH2REGP:
    return new (C) rscratch2RegPOper( );
  case RARG1REGP:
    return new (C) rarg1RegPOper( );
  case RARG2REGP:
    return new (C) rarg2RegPOper( );
  case RARG3REGP:
    return new (C) rarg3RegPOper( );
  case RARG4REGP:
    return new (C) rarg4RegPOper( );
  case IREGNSRC:
    return new (C) iRegNsrcOper( );
  case IREGNDST:
    return new (C) iRegNdstOper( );
  case IREGLDST:
    return new (C) iRegLdstOper( );
  case IREGLSRC:
    return new (C) iRegLsrcOper( );
  case IREGL2ISRC:
    return new (C) iRegL2IsrcOper( );
  case RSCRATCH1REGL:
    return new (C) rscratch1RegLOper( );
  case RSCRATCH2REGL:
    return new (C) rscratch2RegLOper( );
  case FLAGSREG:
    return new (C) flagsRegOper( );
  case FLAGSREGCR0:
    return new (C) flagsRegCR0Oper( );
  case FLAGSREGCR1:
    return new (C) flagsRegCR1Oper( );
  case FLAGSREGCR6:
    return new (C) flagsRegCR6Oper( );
  case REGCTR:
    return new (C) regCTROper( );
  case REGD:
    return new (C) regDOper( );
  case REGF:
    return new (C) regFOper( );
  case INLINE_CACHE_REGP:
    return new (C) inline_cache_regPOper( );
  case COMPILER_METHOD_OOP_REGP:
    return new (C) compiler_method_oop_regPOper( );
  case INTERPRETER_METHOD_OOP_REGP:
    return new (C) interpreter_method_oop_regPOper( );
  case IREGP2N:
    return new (C) iRegP2NOper( );
  case IREGN2P:
    return new (C) iRegN2POper( );
  case INDIRECT:
    return new (C) indirectOper( );
  case INDOFFSET16:
    return new (C) indOffset16Oper(_kids[1]->_leaf->get_long() );
  case INDOFFSET16ALG4:
    return new (C) indOffset16Alg4Oper(_kids[1]->_leaf->get_long() );
  case INDIRECTNARROW:
    return new (C) indirectNarrowOper( );
  case INDOFFSET16NARROW:
    return new (C) indOffset16NarrowOper(_kids[1]->_leaf->get_long() );
  case INDOFFSET16NARROWALG4:
    return new (C) indOffset16NarrowAlg4Oper(_kids[1]->_leaf->get_long() );
  case STACKSLOTI:
    return new (C) stackSlotIOper( );
  case STACKSLOTL:
    return new (C) stackSlotLOper( );
  case STACKSLOTP:
    return new (C) stackSlotPOper( );
  case STACKSLOTF:
    return new (C) stackSlotFOper( );
  case STACKSLOTD:
    return new (C) stackSlotDOper( );
  case CMPOP:
    return new (C) cmpOpOper(_leaf->as_Bool()->_test._test );
  case _DECODEN_IREGNSRC_:    return NULL;
  case _DECODENKLASS_IREGNSRC_:    return NULL;
  case _LOADUB_MEMORY_:    return NULL;
  case _LOADUS_MEMORY_:    return NULL;
  case _LOADI_MEMORY_:    return NULL;
  case _CONVI2L__LOADI_MEMORY__:    return NULL;
  case _LOADN_MEMORY_:    return NULL;
  case _LOADP_MEMORYALG4_:    return NULL;
  case _ADDP_INDIRECTMEMORY_IREGLSRC:    return NULL;
  case _CONVL2I_IREGLSRC_:    return NULL;
  case _BINARY_FLAGSREG_IREGPSRC:    return NULL;
  case _CASTP2X__DECODEN_IREGNSRC__:    return NULL;
  case _BINARY_IREGLSRC_IREGPDST:    return NULL;
  case _BINARY_IREGLSRC_IREGPSRC:    return NULL;
  case _BINARY_IREGLSRC_IREGNSRC:    return NULL;
  case _BINARY_CMPOP_FLAGSREG:    return NULL;
  case _BINARY_IREGIDST_IREGISRC:    return NULL;
  case _BINARY_IREGIDST_IMMI16:    return NULL;
  case _BINARY_IREGLDST_IREGLSRC:    return NULL;
  case _BINARY_IREGLDST_IMML16:    return NULL;
  case _BINARY_IREGNDST_IREGNSRC:    return NULL;
  case _BINARY_IREGNDST_IMMN_0:    return NULL;
  case _BINARY_IREGPDST_IREGPSRC:    return NULL;
  case _BINARY_IREGPDST_IREGP_N2P:    return NULL;
  case _BINARY_IREGPDST_IMMP_0:    return NULL;
  case _BINARY_REGF_REGF:    return NULL;
  case _BINARY_REGD_REGD:    return NULL;
  case _BINARY_IREGLSRC_IREGLSRC:    return NULL;
  case _BINARY_IREGPSRC_IREGPSRC:    return NULL;
  case _BINARY_IREGISRC_IREGISRC:    return NULL;
  case _BINARY_IREGNSRC_IREGNSRC:    return NULL;
  case _ADDI_IREGISRC_IREGISRC:    return NULL;
  case _ADDI__ADDI_IREGISRC_IREGISRC_IREGISRC:    return NULL;
  case _ADDI_IREGISRC__ADDI_IREGISRC_IREGISRC:    return NULL;
  case _ADDL_IREGLSRC_IREGLSRC:    return NULL;
  case _ADDL__ADDL_IREGLSRC_IREGLSRC_IREGLSRC:    return NULL;
  case _ADDL_IREGLSRC__ADDL_IREGLSRC_IREGLSRC:    return NULL;
  case _SUBL_IREGLSRC_IREGLSRC:    return NULL;
  case _SUBL_IMML_0_IREGLSRC:    return NULL;
  case _ANDI_IREGISRC_IMMINEGPOW2:    return NULL;
  case _RSHIFTI_IREGISRC_UIMMI5:    return NULL;
  case _ANDI__RSHIFTI_IREGISRC_UIMMI5_IMMINEGPOW2:    return NULL;
  case _CONVI2L_IREGISRC_:    return NULL;
  case _RSHIFTL_IREGLSRC_IMMI:    return NULL;
  case _URSHIFTL_IREGLSRC_IMMI:    return NULL;
  case _CASTP2X_IREGP_N2P_:    return NULL;
  case _LSHIFTI_IREGISRC_IMMI8:    return NULL;
  case _URSHIFTI_IREGISRC_IMMI8:    return NULL;
  case _ABSF_REGF_:    return NULL;
  case _ABSD_REGD_:    return NULL;
  case _CONVF2D_REGF_:    return NULL;
  case _SQRTD__CONVF2D_REGF__:    return NULL;
  case _ANDL_IREGLSRC_IMMLPOW2MINUS1:    return NULL;
  case _ORI_IREGISRC_IREGISRC:    return NULL;
  case _ORI__ORI_IREGISRC_IREGISRC_IREGISRC:    return NULL;
  case _ORI_IREGISRC__ORI_IREGISRC_IREGISRC:    return NULL;
  case _ORL_IREGLSRC_IREGLSRC:    return NULL;
  case _XORI_IREGISRC_IREGISRC:    return NULL;
  case _XORI__XORI_IREGISRC_IREGISRC_IREGISRC:    return NULL;
  case _XORI_IREGISRC__XORI_IREGISRC_IREGISRC:    return NULL;
  case _XORL_IREGLSRC_IREGLSRC:    return NULL;
  case _XORI_IREGISRC_IMMI_MINUS1:    return NULL;
  case _CONV2B_IREGISRC_:    return NULL;
  case _ANDI_IREGISRC_IMMIPOWEROF2:    return NULL;
  case _CONV2B_IREGP_N2P_:    return NULL;
  case _LSHIFTI_IREGISRC_IMMI_24:    return NULL;
  case _LSHIFTI_IREGISRC_IMMI_16:    return NULL;
  case _ANDI_IREGISRC_UIMMI16:    return NULL;
  case _ANDL_IREGLSRC_IREGLSRC:    return NULL;
  case _ANDL_IREGLSRC_UIMML16:    return NULL;
  case _CMPU_IREGISRC_UIMMI15:    return NULL;
  case _CMPU_IREGISRC_IREGISRC:    return NULL;
  case _CMPN_IREGNSRC_IMMN_0:    return NULL;
  case _CMPP_IREGP_N2P_IMMP_0:    return NULL;
  case _CASTP2X_IREGPSRC_:    return NULL;
  case _ANDL__CASTP2X_IREGPSRC__IMMLNEGPOW2:    return NULL;
  case _BINARY_IREGPSRC_IREGISRC:    return NULL;
  case _ADDP_IMMP_IMML:    return NULL;
  case _BINARY__ADDP_IMMP_IMML_IMMI_1:    return NULL;
  case _BINARY_RSCRATCH2REGP_IMMI_1:    return NULL;
  case _BINARY_IREGPSRC_RSCRATCH1REGI:    return NULL;
  case _BINARY_IREGPSRC_UIMMI15:    return NULL;
  case _BINARY_IREGPSRC_RSCRATCH2REGI:    return NULL;
  case _BINARY_RARG1REGP_RARG3REGI:    return NULL;
  case _BINARY_RARG2REGP_RARG4REGI:    return NULL;
  
  default:
    fprintf(stderr, "Default MachOper Generator invoked for: \n");
    fprintf(stderr, "   opcode = %d\n", opcode);
    break;
  }
  return NULL;
};


//------------------------- MachNode Generator ---------------
// A switch statement on the dense-packed user-defined type system
// that invokes 'new' on the corresponding class constructor.

MachNode *State::MachNodeGenerator(int opcode, Compile* C){
  switch(opcode) {
  case loadUB_indirect_rule: {
      loadUB_indirectNode *node = new (C) loadUB_indirectNode();
      return node;
    }
  case loadUB_indirect_ac_rule: {
      loadUB_indirect_acNode *node = new (C) loadUB_indirect_acNode();
      return node;
    }
  case loadB_indirect_Ex_rule: {
      loadB_indirect_ExNode *node = new (C) loadB_indirect_ExNode();
      return node;
    }
  case loadB_indirect_ac_Ex_rule: {
      loadB_indirect_ac_ExNode *node = new (C) loadB_indirect_ac_ExNode();
      return node;
    }
  case loadUB_indOffset16_rule: {
      loadUB_indOffset16Node *node = new (C) loadUB_indOffset16Node();
      return node;
    }
  case loadUB_indOffset16_ac_rule: {
      loadUB_indOffset16_acNode *node = new (C) loadUB_indOffset16_acNode();
      return node;
    }
  case loadB_indOffset16_Ex_rule: {
      loadB_indOffset16_ExNode *node = new (C) loadB_indOffset16_ExNode();
      return node;
    }
  case loadB_indOffset16_ac_Ex_rule: {
      loadB_indOffset16_ac_ExNode *node = new (C) loadB_indOffset16_ac_ExNode();
      return node;
    }
  case loadUB_rule: {
      loadUBNode *node = new (C) loadUBNode();
      return node;
    }
  case loadUB_ac_rule: {
      loadUB_acNode *node = new (C) loadUB_acNode();
      return node;
    }
  case loadUB2L_rule: {
      loadUB2LNode *node = new (C) loadUB2LNode();
      return node;
    }
  case loadUB2L_ac_rule: {
      loadUB2L_acNode *node = new (C) loadUB2L_acNode();
      return node;
    }
  case loadS_rule: {
      loadSNode *node = new (C) loadSNode();
      return node;
    }
  case loadS_ac_rule: {
      loadS_acNode *node = new (C) loadS_acNode();
      return node;
    }
  case loadUS_rule: {
      loadUSNode *node = new (C) loadUSNode();
      return node;
    }
  case loadUS_ac_rule: {
      loadUS_acNode *node = new (C) loadUS_acNode();
      return node;
    }
  case loadUS2L_rule: {
      loadUS2LNode *node = new (C) loadUS2LNode();
      return node;
    }
  case loadUS2L_ac_rule: {
      loadUS2L_acNode *node = new (C) loadUS2L_acNode();
      return node;
    }
  case loadI_rule: {
      loadINode *node = new (C) loadINode();
      return node;
    }
  case loadI_ac_rule: {
      loadI_acNode *node = new (C) loadI_acNode();
      return node;
    }
  case loadUI2L_rule: {
      loadUI2LNode *node = new (C) loadUI2LNode();
      return node;
    }
  case loadI2L_rule: {
      loadI2LNode *node = new (C) loadI2LNode();
      return node;
    }
  case loadI2L_ac_rule: {
      loadI2L_acNode *node = new (C) loadI2L_acNode();
      return node;
    }
  case loadL_rule: {
      loadLNode *node = new (C) loadLNode();
      return node;
    }
  case loadL_ac_rule: {
      loadL_acNode *node = new (C) loadL_acNode();
      return node;
    }
  case loadL_unaligned_rule: {
      loadL_unalignedNode *node = new (C) loadL_unalignedNode();
      return node;
    }
  case loadV8_rule: {
      loadV8Node *node = new (C) loadV8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadRange_rule: {
      loadRangeNode *node = new (C) loadRangeNode();
      return node;
    }
  case loadN_rule: {
      loadNNode *node = new (C) loadNNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadN_ac_rule: {
      loadN_acNode *node = new (C) loadN_acNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadN2P_unscaled_rule: {
      loadN2P_unscaledNode *node = new (C) loadN2P_unscaledNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadP_rule: {
      loadPNode *node = new (C) loadPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadP_ac_rule: {
      loadP_acNode *node = new (C) loadP_acNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadP2X_rule: {
      loadP2XNode *node = new (C) loadP2XNode();
      return node;
    }
  case loadNKlass_rule: {
      loadNKlassNode *node = new (C) loadNKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadKlass_rule: {
      loadKlassNode *node = new (C) loadKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadF_rule: {
      loadFNode *node = new (C) loadFNode();
      return node;
    }
  case loadF_ac_rule: {
      loadF_acNode *node = new (C) loadF_acNode();
      return node;
    }
  case loadD_rule: {
      loadDNode *node = new (C) loadDNode();
      return node;
    }
  case loadD_ac_rule: {
      loadD_acNode *node = new (C) loadD_acNode();
      return node;
    }
  case loadD_unaligned_rule: {
      loadD_unalignedNode *node = new (C) loadD_unalignedNode();
      return node;
    }
  case loadConI16_rule: {
      loadConI16Node *node = new (C) loadConI16Node();
      node->_opnd_array[1] = new (C) immI16Oper(_leaf->get_int() );
      return node;
    }
  case loadConIhi16_rule: {
      loadConIhi16Node *node = new (C) loadConIhi16Node();
      node->_opnd_array[1] = new (C) immIhi16Oper(_leaf->get_int() );
      return node;
    }
  case loadConI_Ex_rule: {
      loadConI_ExNode *node = new (C) loadConI_ExNode();
      node->_opnd_array[1] = new (C) immIOper(_leaf->get_int() );
      return node;
    }
  case loadConL16_rule: {
      loadConL16Node *node = new (C) loadConL16Node();
      node->_opnd_array[1] = new (C) immL16Oper(_leaf->get_long() );
      return node;
    }
  case loadConL32hi16_rule: {
      loadConL32hi16Node *node = new (C) loadConL32hi16Node();
      node->_opnd_array[1] = new (C) immL32hi16Oper(_leaf->get_long() );
      return node;
    }
  case loadConL32_Ex_rule: {
      loadConL32_ExNode *node = new (C) loadConL32_ExNode();
      node->_opnd_array[1] = new (C) immL32Oper(_leaf->get_long() );
      return node;
    }
  case loadConLhighest16_Ex_rule: {
      loadConLhighest16_ExNode *node = new (C) loadConLhighest16_ExNode();
      node->_opnd_array[1] = new (C) immLhighest16Oper(_leaf->get_long() );
      return node;
    }
  case loadConL_Ex_rule: {
      loadConL_ExNode *node = new (C) loadConL_ExNode();
      node->_opnd_array[1] = new (C) immLOper(_leaf->get_long() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConN0_rule: {
      loadConN0Node *node = new (C) loadConN0Node();
      node->_opnd_array[1] = new (C) immN_0Oper(_leaf->bottom_type()->is_narrowoop() );
      return node;
    }
  case loadConN_Ex_rule: {
      loadConN_ExNode *node = new (C) loadConN_ExNode();
      node->_opnd_array[1] = new (C) immNOper(_leaf->bottom_type()->is_narrowoop() );
      return node;
    }
  case loadConNKlass_hi_rule: {
      loadConNKlass_hiNode *node = new (C) loadConNKlass_hiNode();
      node->_opnd_array[1] = new (C) immNKlass_NMOper(_leaf->bottom_type()->is_narrowklass() );
      return node;
    }
  case loadConNKlass_mask_rule: {
      loadConNKlass_maskNode *node = new (C) loadConNKlass_maskNode();
      node->set_opnd_array(2, MachOperGenerator(IREGNSRC, C));
      return node;
    }
  case loadConNKlass_lo_rule: {
      loadConNKlass_loNode *node = new (C) loadConNKlass_loNode();
      node->set_opnd_array(2, MachOperGenerator(IREGNSRC, C));
      return node;
    }
  case loadConNKlass_Ex_rule: {
      loadConNKlass_ExNode *node = new (C) loadConNKlass_ExNode();
      node->_opnd_array[1] = new (C) immNKlassOper(_leaf->bottom_type()->is_narrowklass() );
      return node;
    }
  case loadConP0or1_rule: {
      loadConP0or1Node *node = new (C) loadConP0or1Node();
      node->_opnd_array[1] = new (C) immP_0or1Oper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConP_rule: {
      loadConPNode *node = new (C) loadConPNode();
      node->set_opnd_array(2, MachOperGenerator(IREGLDST, C));
      return node;
    }
  case loadConP_lo_rule: {
      loadConP_loNode *node = new (C) loadConP_loNode();
      node->set_opnd_array(2, MachOperGenerator(IREGLDST, C));
      return node;
    }
  case loadConP_Ex_rule: {
      loadConP_ExNode *node = new (C) loadConP_ExNode();
      node->_opnd_array[1] = new (C) immPOper(_leaf->bottom_type()->is_ptr() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConF_Ex_rule: {
      loadConF_ExNode *node = new (C) loadConF_ExNode();
      node->_opnd_array[1] = new (C) immFOper(_leaf->getf() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConD_Ex_rule: {
      loadConD_ExNode *node = new (C) loadConD_ExNode();
      node->_opnd_array[1] = new (C) immDOper(_leaf->getd() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case prefetchr_rule: {
      prefetchrNode *node = new (C) prefetchrNode();
      return node;
    }
  case prefetchr_no_offset_rule: {
      prefetchr_no_offsetNode *node = new (C) prefetchr_no_offsetNode();
      return node;
    }
  case prefetchw_rule: {
      prefetchwNode *node = new (C) prefetchwNode();
      return node;
    }
  case prefetchw_no_offset_rule: {
      prefetchw_no_offsetNode *node = new (C) prefetchw_no_offsetNode();
      return node;
    }
  case prefetch_alloc_zero_rule: {
      prefetch_alloc_zeroNode *node = new (C) prefetch_alloc_zeroNode();
      return node;
    }
  case prefetch_alloc_zero_no_offset_rule: {
      prefetch_alloc_zero_no_offsetNode *node = new (C) prefetch_alloc_zero_no_offsetNode();
      return node;
    }
  case prefetch_alloc_rule: {
      prefetch_allocNode *node = new (C) prefetch_allocNode();
      return node;
    }
  case prefetch_alloc_no_offset_rule: {
      prefetch_alloc_no_offsetNode *node = new (C) prefetch_alloc_no_offsetNode();
      return node;
    }
  case storeB_rule: {
      storeBNode *node = new (C) storeBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeC_rule: {
      storeCNode *node = new (C) storeCNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeI_rule: {
      storeINode *node = new (C) storeINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeI_convL2I_rule: {
      storeI_convL2INode *node = new (C) storeI_convL2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeL_rule: {
      storeLNode *node = new (C) storeLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeA8B_rule: {
      storeA8BNode *node = new (C) storeA8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeN_rule: {
      storeNNode *node = new (C) storeNNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeNKlass_rule: {
      storeNKlassNode *node = new (C) storeNKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeP_rule: {
      storePNode *node = new (C) storePNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeF_rule: {
      storeFNode *node = new (C) storeFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeD_rule: {
      storeDNode *node = new (C) storeDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeCM_CMS_rule: {
      storeCM_CMSNode *node = new (C) storeCM_CMSNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeCM_CMS_ExEx_rule: {
      storeCM_CMS_ExExNode *node = new (C) storeCM_CMS_ExExNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeCM_G1_rule: {
      storeCM_G1Node *node = new (C) storeCM_G1Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodeP_shift_rule: {
      encodeP_shiftNode *node = new (C) encodeP_shiftNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodeP_sub_rule: {
      encodeP_subNode *node = new (C) encodeP_subNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cond_sub_base_rule: {
      cond_sub_baseNode *node = new (C) cond_sub_baseNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cond_set_0_oop_rule: {
      cond_set_0_oopNode *node = new (C) cond_set_0_oopNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodeP_32GAligned_rule: {
      encodeP_32GAlignedNode *node = new (C) encodeP_32GAlignedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodeP_Ex_rule: {
      encodeP_ExNode *node = new (C) encodeP_ExNode();
      node->set_opnd_array(2, MachOperGenerator(FLAGSREG, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodeP_not_null_Ex_rule: {
      encodeP_not_null_ExNode *node = new (C) encodeP_not_null_ExNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodeP_not_null_base_null_rule: {
      encodeP_not_null_base_nullNode *node = new (C) encodeP_not_null_base_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodeP_narrow_oop_shift_0_rule: {
      encodeP_narrow_oop_shift_0Node *node = new (C) encodeP_narrow_oop_shift_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeN_shift_rule: {
      decodeN_shiftNode *node = new (C) decodeN_shiftNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeN_add_rule: {
      decodeN_addNode *node = new (C) decodeN_addNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cond_add_base_rule: {
      cond_add_baseNode *node = new (C) cond_add_baseNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cond_set_0_ptr_rule: {
      cond_set_0_ptrNode *node = new (C) cond_set_0_ptrNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeN_Ex_rule: {
      decodeN_ExNode *node = new (C) decodeN_ExNode();
      node->set_opnd_array(2, MachOperGenerator(FLAGSREG, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeN_nullBase_rule: {
      decodeN_nullBaseNode *node = new (C) decodeN_nullBaseNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeN_notNull_addBase_Ex_rule: {
      decodeN_notNull_addBase_ExNode *node = new (C) decodeN_notNull_addBase_ExNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeN_unscaled_rule: {
      decodeN_unscaledNode *node = new (C) decodeN_unscaledNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeN2I_unscaled_rule: {
      decodeN2I_unscaledNode *node = new (C) decodeN2I_unscaledNode();
      return node;
    }
  case encodePKlass_shift_rule: {
      encodePKlass_shiftNode *node = new (C) encodePKlass_shiftNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodePKlass_sub_base_rule: {
      encodePKlass_sub_baseNode *node = new (C) encodePKlass_sub_baseNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodePKlass_32GAligned_rule: {
      encodePKlass_32GAlignedNode *node = new (C) encodePKlass_32GAlignedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodePKlass_not_null_Ex_rule: {
      encodePKlass_not_null_ExNode *node = new (C) encodePKlass_not_null_ExNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodePKlass_not_null_ExEx_rule: {
      encodePKlass_not_null_ExExNode *node = new (C) encodePKlass_not_null_ExExNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeNKlass_shift_rule: {
      decodeNKlass_shiftNode *node = new (C) decodeNKlass_shiftNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeNKlass_add_base_rule: {
      decodeNKlass_add_baseNode *node = new (C) decodeNKlass_add_baseNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeNKlass_notNull_addBase_Ex_rule: {
      decodeNKlass_notNull_addBase_ExNode *node = new (C) decodeNKlass_notNull_addBase_ExNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeNKlass_notNull_addBase_ExEx_rule: {
      decodeNKlass_notNull_addBase_ExExNode *node = new (C) decodeNKlass_notNull_addBase_ExExNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case membar_acquire_rule: {
      membar_acquireNode *node = new (C) membar_acquireNode();
      return node;
    }
  case unnecessary_membar_acquire_rule: {
      unnecessary_membar_acquireNode *node = new (C) unnecessary_membar_acquireNode();
      return node;
    }
  case membar_acquire_lock_rule: {
      membar_acquire_lockNode *node = new (C) membar_acquire_lockNode();
      return node;
    }
  case membar_release_rule: {
      membar_releaseNode *node = new (C) membar_releaseNode();
      return node;
    }
  case membar_release_0_rule: {
      membar_release_0Node *node = new (C) membar_release_0Node();
      return node;
    }
  case membar_storestore_rule: {
      membar_storestoreNode *node = new (C) membar_storestoreNode();
      return node;
    }
  case membar_release_lock_rule: {
      membar_release_lockNode *node = new (C) membar_release_lockNode();
      return node;
    }
  case membar_volatile_rule: {
      membar_volatileNode *node = new (C) membar_volatileNode();
      return node;
    }
  case membar_CPUOrder_rule: {
      membar_CPUOrderNode *node = new (C) membar_CPUOrderNode();
      return node;
    }
  case cmovI_reg_isel_rule: {
      cmovI_reg_iselNode *node = new (C) cmovI_reg_iselNode();
      return node;
    }
  case cmovI_reg_rule: {
      cmovI_regNode *node = new (C) cmovI_regNode();
      return node;
    }
  case cmovI_imm_rule: {
      cmovI_immNode *node = new (C) cmovI_immNode();
      return node;
    }
  case cmovL_reg_isel_rule: {
      cmovL_reg_iselNode *node = new (C) cmovL_reg_iselNode();
      return node;
    }
  case cmovL_reg_rule: {
      cmovL_regNode *node = new (C) cmovL_regNode();
      return node;
    }
  case cmovL_imm_rule: {
      cmovL_immNode *node = new (C) cmovL_immNode();
      return node;
    }
  case cmovN_reg_isel_rule: {
      cmovN_reg_iselNode *node = new (C) cmovN_reg_iselNode();
      return node;
    }
  case cmovN_reg_rule: {
      cmovN_regNode *node = new (C) cmovN_regNode();
      return node;
    }
  case cmovN_imm_rule: {
      cmovN_immNode *node = new (C) cmovN_immNode();
      return node;
    }
  case cmovP_reg_isel_rule: {
      cmovP_reg_iselNode *node = new (C) cmovP_reg_iselNode();
      return node;
    }
  case cmovP_reg_rule: {
      cmovP_regNode *node = new (C) cmovP_regNode();
      return node;
    }
  case cmovP_imm_rule: {
      cmovP_immNode *node = new (C) cmovP_immNode();
      return node;
    }
  case cmovF_reg_rule: {
      cmovF_regNode *node = new (C) cmovF_regNode();
      return node;
    }
  case cmovD_reg_rule: {
      cmovD_regNode *node = new (C) cmovD_regNode();
      return node;
    }
  case storeLConditional_regP_regL_regL_rule: {
      storeLConditional_regP_regL_regLNode *node = new (C) storeLConditional_regP_regL_regLNode();
      return node;
    }
  case storePConditional_regP_regP_regP_rule: {
      storePConditional_regP_regP_regPNode *node = new (C) storePConditional_regP_regP_regPNode();
      return node;
    }
  case loadPLocked_rule: {
      loadPLockedNode *node = new (C) loadPLockedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndSwapI_regP_regI_regI_rule: {
      compareAndSwapI_regP_regI_regINode *node = new (C) compareAndSwapI_regP_regI_regINode();
      return node;
    }
  case compareAndSwapN_regP_regN_regN_rule: {
      compareAndSwapN_regP_regN_regNNode *node = new (C) compareAndSwapN_regP_regN_regNNode();
      return node;
    }
  case compareAndSwapL_regP_regL_regL_rule: {
      compareAndSwapL_regP_regL_regLNode *node = new (C) compareAndSwapL_regP_regL_regLNode();
      return node;
    }
  case compareAndSwapP_regP_regP_regP_rule: {
      compareAndSwapP_regP_regP_regPNode *node = new (C) compareAndSwapP_regP_regP_regPNode();
      return node;
    }
  case getAndAddI_rule: {
      getAndAddINode *node = new (C) getAndAddINode();
      return node;
    }
  case getAndAddL_rule: {
      getAndAddLNode *node = new (C) getAndAddLNode();
      return node;
    }
  case getAndSetI_rule: {
      getAndSetINode *node = new (C) getAndSetINode();
      return node;
    }
  case getAndSetL_rule: {
      getAndSetLNode *node = new (C) getAndSetLNode();
      return node;
    }
  case getAndSetP_rule: {
      getAndSetPNode *node = new (C) getAndSetPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case getAndSetN_rule: {
      getAndSetNNode *node = new (C) getAndSetNNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addI_reg_reg_rule: {
      addI_reg_regNode *node = new (C) addI_reg_regNode();
      return node;
    }
  case tree_addI_addI_addI_reg_reg_Ex_rule: {
      tree_addI_addI_addI_reg_reg_ExNode *node = new (C) tree_addI_addI_addI_reg_reg_ExNode();
      return node;
    }
  case tree_addI_addI_addI_reg_reg_Ex_1_rule: {
      tree_addI_addI_addI_reg_reg_Ex_1Node *node = new (C) tree_addI_addI_addI_reg_reg_Ex_1Node();
      return node;
    }
  case tree_addI_addI_addI_reg_reg_Ex_0_rule: {
      tree_addI_addI_addI_reg_reg_Ex_0Node *node = new (C) tree_addI_addI_addI_reg_reg_Ex_0Node();
      return node;
    }
  case tree_addI_addI_addI_reg_reg_Ex_2_rule: {
      tree_addI_addI_addI_reg_reg_Ex_2Node *node = new (C) tree_addI_addI_addI_reg_reg_Ex_2Node();
      return node;
    }
  case addI_reg_imm16_rule: {
      addI_reg_imm16Node *node = new (C) addI_reg_imm16Node();
      return node;
    }
  case addI_reg_immhi16_rule: {
      addI_reg_immhi16Node *node = new (C) addI_reg_immhi16Node();
      return node;
    }
  case addL_reg_reg_rule: {
      addL_reg_regNode *node = new (C) addL_reg_regNode();
      return node;
    }
  case tree_addL_addL_addL_reg_reg_Ex_rule: {
      tree_addL_addL_addL_reg_reg_ExNode *node = new (C) tree_addL_addL_addL_reg_reg_ExNode();
      return node;
    }
  case tree_addL_addL_addL_reg_reg_Ex_1_rule: {
      tree_addL_addL_addL_reg_reg_Ex_1Node *node = new (C) tree_addL_addL_addL_reg_reg_Ex_1Node();
      return node;
    }
  case tree_addL_addL_addL_reg_reg_Ex_0_rule: {
      tree_addL_addL_addL_reg_reg_Ex_0Node *node = new (C) tree_addL_addL_addL_reg_reg_Ex_0Node();
      return node;
    }
  case tree_addL_addL_addL_reg_reg_Ex_2_rule: {
      tree_addL_addL_addL_reg_reg_Ex_2Node *node = new (C) tree_addL_addL_addL_reg_reg_Ex_2Node();
      return node;
    }
  case addI_regL_regL_rule: {
      addI_regL_regLNode *node = new (C) addI_regL_regLNode();
      return node;
    }
  case addL_reg_imm16_rule: {
      addL_reg_imm16Node *node = new (C) addL_reg_imm16Node();
      return node;
    }
  case addL_reg_immhi16_rule: {
      addL_reg_immhi16Node *node = new (C) addL_reg_immhi16Node();
      return node;
    }
  case addP_reg_reg_rule: {
      addP_reg_regNode *node = new (C) addP_reg_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addP_reg_imm16_rule: {
      addP_reg_imm16Node *node = new (C) addP_reg_imm16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addP_reg_immhi16_rule: {
      addP_reg_immhi16Node *node = new (C) addP_reg_immhi16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case subI_reg_reg_rule: {
      subI_reg_regNode *node = new (C) subI_reg_regNode();
      return node;
    }
  case subI_reg_imm16_rule: {
      subI_reg_imm16Node *node = new (C) subI_reg_imm16Node();
      return node;
    }
  case subI_imm16_reg_rule: {
      subI_imm16_regNode *node = new (C) subI_imm16_regNode();
      return node;
    }
  case absI_reg_Ex_rule: {
      absI_reg_ExNode *node = new (C) absI_reg_ExNode();
      return node;
    }
  case negI_regI_rule: {
      negI_regINode *node = new (C) negI_regINode();
      return node;
    }
  case subL_reg_reg_rule: {
      subL_reg_regNode *node = new (C) subL_reg_regNode();
      return node;
    }
  case subI_regL_regL_rule: {
      subI_regL_regLNode *node = new (C) subI_regL_regLNode();
      return node;
    }
  case subL_reg_imm16_rule: {
      subL_reg_imm16Node *node = new (C) subL_reg_imm16Node();
      return node;
    }
  case negL_reg_reg_rule: {
      negL_reg_regNode *node = new (C) negL_reg_regNode();
      return node;
    }
  case negI_con0_regL_rule: {
      negI_con0_regLNode *node = new (C) negI_con0_regLNode();
      return node;
    }
  case mulI_reg_reg_rule: {
      mulI_reg_regNode *node = new (C) mulI_reg_regNode();
      return node;
    }
  case mulI_reg_imm16_rule: {
      mulI_reg_imm16Node *node = new (C) mulI_reg_imm16Node();
      return node;
    }
  case mulL_reg_reg_rule: {
      mulL_reg_regNode *node = new (C) mulL_reg_regNode();
      return node;
    }
  case mulHighL_reg_reg_rule: {
      mulHighL_reg_regNode *node = new (C) mulHighL_reg_regNode();
      return node;
    }
  case mulL_reg_imm16_rule: {
      mulL_reg_imm16Node *node = new (C) mulL_reg_imm16Node();
      return node;
    }
  case divI_reg_immIvalueMinus1_rule: {
      divI_reg_immIvalueMinus1Node *node = new (C) divI_reg_immIvalueMinus1Node();
      return node;
    }
  case divI_reg_regnotMinus1_rule: {
      divI_reg_regnotMinus1Node *node = new (C) divI_reg_regnotMinus1Node();
      return node;
    }
  case divI_reg_reg_Ex_rule: {
      divI_reg_reg_ExNode *node = new (C) divI_reg_reg_ExNode();
      return node;
    }
  case divL_reg_immLvalueMinus1_rule: {
      divL_reg_immLvalueMinus1Node *node = new (C) divL_reg_immLvalueMinus1Node();
      return node;
    }
  case divL_reg_regnotMinus1_rule: {
      divL_reg_regnotMinus1Node *node = new (C) divL_reg_regnotMinus1Node();
      return node;
    }
  case divL_reg_reg_Ex_rule: {
      divL_reg_reg_ExNode *node = new (C) divL_reg_reg_ExNode();
      return node;
    }
  case modI_reg_reg_Ex_rule: {
      modI_reg_reg_ExNode *node = new (C) modI_reg_reg_ExNode();
      return node;
    }
  case modL_reg_reg_Ex_rule: {
      modL_reg_reg_ExNode *node = new (C) modL_reg_reg_ExNode();
      return node;
    }
  case lShiftI_reg_reg_Ex_rule: {
      lShiftI_reg_reg_ExNode *node = new (C) lShiftI_reg_reg_ExNode();
      return node;
    }
  case lShiftI_reg_imm_rule: {
      lShiftI_reg_immNode *node = new (C) lShiftI_reg_immNode();
      return node;
    }
  case lShiftI_andI_immInegpow2_imm5_rule: {
      lShiftI_andI_immInegpow2_imm5Node *node = new (C) lShiftI_andI_immInegpow2_imm5Node();
      return node;
    }
  case lShiftI_andI_immInegpow2_rShiftI_imm5_rule: {
      lShiftI_andI_immInegpow2_rShiftI_imm5Node *node = new (C) lShiftI_andI_immInegpow2_rShiftI_imm5Node();
      return node;
    }
  case lShiftL_regL_regI_Ex_rule: {
      lShiftL_regL_regI_ExNode *node = new (C) lShiftL_regL_regI_ExNode();
      return node;
    }
  case lshiftL_regL_immI_rule: {
      lshiftL_regL_immINode *node = new (C) lshiftL_regL_immINode();
      return node;
    }
  case lShiftL_regI_immGE32_rule: {
      lShiftL_regI_immGE32Node *node = new (C) lShiftL_regI_immGE32Node();
      return node;
    }
  case scaledPositiveI2L_lShiftL_convI2L_reg_imm6_rule: {
      scaledPositiveI2L_lShiftL_convI2L_reg_imm6Node *node = new (C) scaledPositiveI2L_lShiftL_convI2L_reg_imm6Node();
      return node;
    }
  case arShiftI_reg_reg_Ex_rule: {
      arShiftI_reg_reg_ExNode *node = new (C) arShiftI_reg_reg_ExNode();
      return node;
    }
  case arShiftI_reg_imm_rule: {
      arShiftI_reg_immNode *node = new (C) arShiftI_reg_immNode();
      return node;
    }
  case arShiftL_regL_regI_Ex_rule: {
      arShiftL_regL_regI_ExNode *node = new (C) arShiftL_regL_regI_ExNode();
      return node;
    }
  case arShiftL_regL_immI_rule: {
      arShiftL_regL_immINode *node = new (C) arShiftL_regL_immINode();
      return node;
    }
  case convL2I_arShiftL_regL_immI_rule: {
      convL2I_arShiftL_regL_immINode *node = new (C) convL2I_arShiftL_regL_immINode();
      return node;
    }
  case urShiftI_reg_reg_Ex_rule: {
      urShiftI_reg_reg_ExNode *node = new (C) urShiftI_reg_reg_ExNode();
      return node;
    }
  case urShiftI_reg_imm_rule: {
      urShiftI_reg_immNode *node = new (C) urShiftI_reg_immNode();
      return node;
    }
  case urShiftL_regL_regI_Ex_rule: {
      urShiftL_regL_regI_ExNode *node = new (C) urShiftL_regL_regI_ExNode();
      return node;
    }
  case urShiftL_regL_immI_rule: {
      urShiftL_regL_immINode *node = new (C) urShiftL_regL_immINode();
      return node;
    }
  case convL2I_urShiftL_regL_immI_rule: {
      convL2I_urShiftL_regL_immINode *node = new (C) convL2I_urShiftL_regL_immINode();
      return node;
    }
  case shrP_convP2X_reg_imm6_rule: {
      shrP_convP2X_reg_imm6Node *node = new (C) shrP_convP2X_reg_imm6Node();
      return node;
    }
  case sxtI_reg_rule: {
      sxtI_regNode *node = new (C) sxtI_regNode();
      return node;
    }
  case rotlI_reg_immi8_rule: {
      rotlI_reg_immi8Node *node = new (C) rotlI_reg_immi8Node();
      return node;
    }
  case rotlI_reg_immi8_0_rule: {
      rotlI_reg_immi8_0Node *node = new (C) rotlI_reg_immi8_0Node();
      return node;
    }
  case rotrI_reg_immi8_rule: {
      rotrI_reg_immi8Node *node = new (C) rotrI_reg_immi8Node();
      return node;
    }
  case rotrI_reg_immi8_0_rule: {
      rotrI_reg_immi8_0Node *node = new (C) rotrI_reg_immi8_0Node();
      return node;
    }
  case addF_reg_reg_rule: {
      addF_reg_regNode *node = new (C) addF_reg_regNode();
      return node;
    }
  case addD_reg_reg_rule: {
      addD_reg_regNode *node = new (C) addD_reg_regNode();
      return node;
    }
  case subF_reg_reg_rule: {
      subF_reg_regNode *node = new (C) subF_reg_regNode();
      return node;
    }
  case subD_reg_reg_rule: {
      subD_reg_regNode *node = new (C) subD_reg_regNode();
      return node;
    }
  case mulF_reg_reg_rule: {
      mulF_reg_regNode *node = new (C) mulF_reg_regNode();
      return node;
    }
  case mulD_reg_reg_rule: {
      mulD_reg_regNode *node = new (C) mulD_reg_regNode();
      return node;
    }
  case divF_reg_reg_rule: {
      divF_reg_regNode *node = new (C) divF_reg_regNode();
      return node;
    }
  case divD_reg_reg_rule: {
      divD_reg_regNode *node = new (C) divD_reg_regNode();
      return node;
    }
  case absF_reg_rule: {
      absF_regNode *node = new (C) absF_regNode();
      return node;
    }
  case absD_reg_rule: {
      absD_regNode *node = new (C) absD_regNode();
      return node;
    }
  case negF_reg_rule: {
      negF_regNode *node = new (C) negF_regNode();
      return node;
    }
  case negD_reg_rule: {
      negD_regNode *node = new (C) negD_regNode();
      return node;
    }
  case negF_absF_reg_rule: {
      negF_absF_regNode *node = new (C) negF_absF_regNode();
      return node;
    }
  case negD_absD_reg_rule: {
      negD_absD_regNode *node = new (C) negD_absD_regNode();
      return node;
    }
  case sqrtD_reg_rule: {
      sqrtD_regNode *node = new (C) sqrtD_regNode();
      return node;
    }
  case sqrtF_reg_rule: {
      sqrtF_regNode *node = new (C) sqrtF_regNode();
      return node;
    }
  case roundDouble_nop_rule: {
      roundDouble_nopNode *node = new (C) roundDouble_nopNode();
      return node;
    }
  case roundFloat_nop_rule: {
      roundFloat_nopNode *node = new (C) roundFloat_nopNode();
      return node;
    }
  case andI_reg_reg_rule: {
      andI_reg_regNode *node = new (C) andI_reg_regNode();
      return node;
    }
  case andI_reg_uimm16_rule: {
      andI_reg_uimm16Node *node = new (C) andI_reg_uimm16Node();
      return node;
    }
  case andI_reg_immInegpow2_rule: {
      andI_reg_immInegpow2Node *node = new (C) andI_reg_immInegpow2Node();
      return node;
    }
  case andI_reg_immIpow2minus1_rule: {
      andI_reg_immIpow2minus1Node *node = new (C) andI_reg_immIpow2minus1Node();
      return node;
    }
  case andI_reg_immIpowerOf2_rule: {
      andI_reg_immIpowerOf2Node *node = new (C) andI_reg_immIpowerOf2Node();
      return node;
    }
  case andL_reg_reg_rule: {
      andL_reg_regNode *node = new (C) andL_reg_regNode();
      return node;
    }
  case andL_reg_uimm16_rule: {
      andL_reg_uimm16Node *node = new (C) andL_reg_uimm16Node();
      return node;
    }
  case andL_reg_immLnegpow2_rule: {
      andL_reg_immLnegpow2Node *node = new (C) andL_reg_immLnegpow2Node();
      return node;
    }
  case andL_reg_immLpow2minus1_rule: {
      andL_reg_immLpow2minus1Node *node = new (C) andL_reg_immLpow2minus1Node();
      return node;
    }
  case convL2I_andL_reg_immLpow2minus1_rule: {
      convL2I_andL_reg_immLpow2minus1Node *node = new (C) convL2I_andL_reg_immLpow2minus1Node();
      return node;
    }
  case orI_reg_reg_rule: {
      orI_reg_regNode *node = new (C) orI_reg_regNode();
      return node;
    }
  case tree_orI_orI_orI_reg_reg_Ex_rule: {
      tree_orI_orI_orI_reg_reg_ExNode *node = new (C) tree_orI_orI_orI_reg_reg_ExNode();
      return node;
    }
  case tree_orI_orI_orI_reg_reg_Ex_1_rule: {
      tree_orI_orI_orI_reg_reg_Ex_1Node *node = new (C) tree_orI_orI_orI_reg_reg_Ex_1Node();
      return node;
    }
  case tree_orI_orI_orI_reg_reg_Ex_0_rule: {
      tree_orI_orI_orI_reg_reg_Ex_0Node *node = new (C) tree_orI_orI_orI_reg_reg_Ex_0Node();
      return node;
    }
  case tree_orI_orI_orI_reg_reg_Ex_2_rule: {
      tree_orI_orI_orI_reg_reg_Ex_2Node *node = new (C) tree_orI_orI_orI_reg_reg_Ex_2Node();
      return node;
    }
  case orI_reg_uimm16_rule: {
      orI_reg_uimm16Node *node = new (C) orI_reg_uimm16Node();
      return node;
    }
  case orL_reg_reg_rule: {
      orL_reg_regNode *node = new (C) orL_reg_regNode();
      return node;
    }
  case orI_regL_regL_rule: {
      orI_regL_regLNode *node = new (C) orI_regL_regLNode();
      return node;
    }
  case orL_reg_uimm16_rule: {
      orL_reg_uimm16Node *node = new (C) orL_reg_uimm16Node();
      return node;
    }
  case xorI_reg_reg_rule: {
      xorI_reg_regNode *node = new (C) xorI_reg_regNode();
      return node;
    }
  case tree_xorI_xorI_xorI_reg_reg_Ex_rule: {
      tree_xorI_xorI_xorI_reg_reg_ExNode *node = new (C) tree_xorI_xorI_xorI_reg_reg_ExNode();
      return node;
    }
  case tree_xorI_xorI_xorI_reg_reg_Ex_1_rule: {
      tree_xorI_xorI_xorI_reg_reg_Ex_1Node *node = new (C) tree_xorI_xorI_xorI_reg_reg_Ex_1Node();
      return node;
    }
  case tree_xorI_xorI_xorI_reg_reg_Ex_0_rule: {
      tree_xorI_xorI_xorI_reg_reg_Ex_0Node *node = new (C) tree_xorI_xorI_xorI_reg_reg_Ex_0Node();
      return node;
    }
  case tree_xorI_xorI_xorI_reg_reg_Ex_2_rule: {
      tree_xorI_xorI_xorI_reg_reg_Ex_2Node *node = new (C) tree_xorI_xorI_xorI_reg_reg_Ex_2Node();
      return node;
    }
  case xorI_reg_uimm16_rule: {
      xorI_reg_uimm16Node *node = new (C) xorI_reg_uimm16Node();
      return node;
    }
  case xorL_reg_reg_rule: {
      xorL_reg_regNode *node = new (C) xorL_reg_regNode();
      return node;
    }
  case xorI_regL_regL_rule: {
      xorI_regL_regLNode *node = new (C) xorI_regL_regLNode();
      return node;
    }
  case xorL_reg_uimm16_rule: {
      xorL_reg_uimm16Node *node = new (C) xorL_reg_uimm16Node();
      return node;
    }
  case notI_reg_rule: {
      notI_regNode *node = new (C) notI_regNode();
      return node;
    }
  case notL_reg_rule: {
      notL_regNode *node = new (C) notL_regNode();
      return node;
    }
  case andcI_reg_reg_rule: {
      andcI_reg_regNode *node = new (C) andcI_reg_regNode();
      return node;
    }
  case andcI_reg_reg_0_rule: {
      andcI_reg_reg_0Node *node = new (C) andcI_reg_reg_0Node();
      return node;
    }
  case stkI_to_regI_rule: {
      stkI_to_regINode *node = new (C) stkI_to_regINode();
      return node;
    }
  case regI_to_stkI_rule: {
      regI_to_stkINode *node = new (C) regI_to_stkINode();
      return node;
    }
  case stkL_to_regL_rule: {
      stkL_to_regLNode *node = new (C) stkL_to_regLNode();
      return node;
    }
  case regL_to_stkL_rule: {
      regL_to_stkLNode *node = new (C) regL_to_stkLNode();
      return node;
    }
  case moveF2I_stack_reg_rule: {
      moveF2I_stack_regNode *node = new (C) moveF2I_stack_regNode();
      return node;
    }
  case moveF2I_reg_stack_rule: {
      moveF2I_reg_stackNode *node = new (C) moveF2I_reg_stackNode();
      return node;
    }
  case moveI2F_stack_reg_rule: {
      moveI2F_stack_regNode *node = new (C) moveI2F_stack_regNode();
      return node;
    }
  case moveI2F_reg_stack_rule: {
      moveI2F_reg_stackNode *node = new (C) moveI2F_reg_stackNode();
      return node;
    }
  case moveD2L_stack_reg_rule: {
      moveD2L_stack_regNode *node = new (C) moveD2L_stack_regNode();
      return node;
    }
  case moveD2L_reg_stack_rule: {
      moveD2L_reg_stackNode *node = new (C) moveD2L_reg_stackNode();
      return node;
    }
  case moveL2D_stack_reg_rule: {
      moveL2D_stack_regNode *node = new (C) moveL2D_stack_regNode();
      return node;
    }
  case moveL2D_reg_stack_rule: {
      moveL2D_reg_stackNode *node = new (C) moveL2D_reg_stackNode();
      return node;
    }
  case castX2P_rule: {
      castX2PNode *node = new (C) castX2PNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castP2X_rule: {
      castP2XNode *node = new (C) castP2XNode();
      return node;
    }
  case castPP_rule: {
      castPPNode *node = new (C) castPPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castII_rule: {
      castIINode *node = new (C) castIINode();
      return node;
    }
  case checkCastPP_rule: {
      checkCastPPNode *node = new (C) checkCastPPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case convI2Bool_reg__cntlz_Ex_rule: {
      convI2Bool_reg__cntlz_ExNode *node = new (C) convI2Bool_reg__cntlz_ExNode();
      return node;
    }
  case convI2Bool_reg__cmove_rule: {
      convI2Bool_reg__cmoveNode *node = new (C) convI2Bool_reg__cmoveNode();
      node->set_opnd_array(2, MachOperGenerator(FLAGSREG, C));
      return node;
    }
  case xorI_convI2Bool_reg_immIvalue1__cntlz_Ex_rule: {
      xorI_convI2Bool_reg_immIvalue1__cntlz_ExNode *node = new (C) xorI_convI2Bool_reg_immIvalue1__cntlz_ExNode();
      return node;
    }
  case xorI_convI2Bool_reg_immIvalue1__cmove_rule: {
      xorI_convI2Bool_reg_immIvalue1__cmoveNode *node = new (C) xorI_convI2Bool_reg_immIvalue1__cmoveNode();
      node->set_opnd_array(3, MachOperGenerator(FLAGSREG, C));
      return node;
    }
  case convI2Bool_andI_reg_immIpowerOf2_rule: {
      convI2Bool_andI_reg_immIpowerOf2Node *node = new (C) convI2Bool_andI_reg_immIpowerOf2Node();
      return node;
    }
  case convP2Bool_reg__cntlz_Ex_rule: {
      convP2Bool_reg__cntlz_ExNode *node = new (C) convP2Bool_reg__cntlz_ExNode();
      return node;
    }
  case convP2Bool_reg__cmove_rule: {
      convP2Bool_reg__cmoveNode *node = new (C) convP2Bool_reg__cmoveNode();
      node->set_opnd_array(2, MachOperGenerator(FLAGSREG, C));
      return node;
    }
  case xorI_convP2Bool_reg__cntlz_Ex_rule: {
      xorI_convP2Bool_reg__cntlz_ExNode *node = new (C) xorI_convP2Bool_reg__cntlz_ExNode();
      return node;
    }
  case xorI_convP2Bool_reg_immIvalue1__cmove_rule: {
      xorI_convP2Bool_reg_immIvalue1__cmoveNode *node = new (C) xorI_convP2Bool_reg_immIvalue1__cmoveNode();
      node->set_opnd_array(3, MachOperGenerator(FLAGSREG, C));
      return node;
    }
  case cmpLTMask_reg_reg_Ex_rule: {
      cmpLTMask_reg_reg_ExNode *node = new (C) cmpLTMask_reg_reg_ExNode();
      return node;
    }
  case cmpLTMask_reg_immI0_rule: {
      cmpLTMask_reg_immI0Node *node = new (C) cmpLTMask_reg_immI0Node();
      return node;
    }
  case convB2I_reg_rule: {
      convB2I_regNode *node = new (C) convB2I_regNode();
      return node;
    }
  case convS2I_reg_rule: {
      convS2I_regNode *node = new (C) convS2I_regNode();
      return node;
    }
  case sxtI_L2L_reg_rule: {
      sxtI_L2L_regNode *node = new (C) sxtI_L2L_regNode();
      return node;
    }
  case convL2I_reg_rule: {
      convL2I_regNode *node = new (C) convL2I_regNode();
      return node;
    }
  case convD2I_reg_ExEx_rule: {
      convD2I_reg_ExExNode *node = new (C) convD2I_reg_ExExNode();
      return node;
    }
  case convF2I_regF_ExEx_rule: {
      convF2I_regF_ExExNode *node = new (C) convF2I_regF_ExExNode();
      return node;
    }
  case convI2L_reg_rule: {
      convI2L_regNode *node = new (C) convI2L_regNode();
      return node;
    }
  case zeroExtendL_regI_rule: {
      zeroExtendL_regINode *node = new (C) zeroExtendL_regINode();
      return node;
    }
  case zeroExtendL_regL_rule: {
      zeroExtendL_regLNode *node = new (C) zeroExtendL_regLNode();
      return node;
    }
  case convF2L_reg_ExEx_rule: {
      convF2L_reg_ExExNode *node = new (C) convF2L_reg_ExExNode();
      return node;
    }
  case convD2L_reg_ExEx_rule: {
      convD2L_reg_ExExNode *node = new (C) convD2L_reg_ExExNode();
      return node;
    }
  case convD2F_reg_rule: {
      convD2F_regNode *node = new (C) convD2F_regNode();
      return node;
    }
  case convI2F_ireg_Ex_rule: {
      convI2F_ireg_ExNode *node = new (C) convI2F_ireg_ExNode();
      return node;
    }
  case convI2F_ireg_fcfids_Ex_rule: {
      convI2F_ireg_fcfids_ExNode *node = new (C) convI2F_ireg_fcfids_ExNode();
      return node;
    }
  case convL2F_ireg_fcfids_Ex_rule: {
      convL2F_ireg_fcfids_ExNode *node = new (C) convL2F_ireg_fcfids_ExNode();
      return node;
    }
  case convI2D_reg_Ex_rule: {
      convI2D_reg_ExNode *node = new (C) convI2D_reg_ExNode();
      return node;
    }
  case convL2D_reg_Ex_rule: {
      convL2D_reg_ExNode *node = new (C) convL2D_reg_ExNode();
      return node;
    }
  case convF2D_reg_rule: {
      convF2D_regNode *node = new (C) convF2D_regNode();
      return node;
    }
  case cmpI_reg_reg_rule: {
      cmpI_reg_regNode *node = new (C) cmpI_reg_regNode();
      return node;
    }
  case cmpI_reg_imm16_rule: {
      cmpI_reg_imm16Node *node = new (C) cmpI_reg_imm16Node();
      return node;
    }
  case testI_reg_imm_rule: {
      testI_reg_immNode *node = new (C) testI_reg_immNode();
      return node;
    }
  case cmpL_reg_reg_rule: {
      cmpL_reg_regNode *node = new (C) cmpL_reg_regNode();
      return node;
    }
  case cmpL_reg_imm16_rule: {
      cmpL_reg_imm16Node *node = new (C) cmpL_reg_imm16Node();
      return node;
    }
  case testL_reg_reg_rule: {
      testL_reg_regNode *node = new (C) testL_reg_regNode();
      return node;
    }
  case testL_reg_imm_rule: {
      testL_reg_immNode *node = new (C) testL_reg_immNode();
      return node;
    }
  case cmpL3_reg_reg_ExEx_rule: {
      cmpL3_reg_reg_ExExNode *node = new (C) cmpL3_reg_reg_ExExNode();
      return node;
    }
  case rangeCheck_iReg_uimm15_rule: {
      rangeCheck_iReg_uimm15Node *node = new (C) rangeCheck_iReg_uimm15Node();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case rangeCheck_iReg_iReg_rule: {
      rangeCheck_iReg_iRegNode *node = new (C) rangeCheck_iReg_iRegNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case rangeCheck_uimm15_iReg_rule: {
      rangeCheck_uimm15_iRegNode *node = new (C) rangeCheck_uimm15_iRegNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case compU_reg_reg_rule: {
      compU_reg_regNode *node = new (C) compU_reg_regNode();
      return node;
    }
  case compU_reg_uimm16_rule: {
      compU_reg_uimm16Node *node = new (C) compU_reg_uimm16Node();
      return node;
    }
  case zeroCheckN_iReg_imm0_rule: {
      zeroCheckN_iReg_imm0Node *node = new (C) zeroCheckN_iReg_imm0Node();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpN_reg_reg_rule: {
      cmpN_reg_regNode *node = new (C) cmpN_reg_regNode();
      return node;
    }
  case cmpN_reg_imm0_rule: {
      cmpN_reg_imm0Node *node = new (C) cmpN_reg_imm0Node();
      return node;
    }
  case zeroCheckP_reg_imm0_rule: {
      zeroCheckP_reg_imm0Node *node = new (C) zeroCheckP_reg_imm0Node();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpP_reg_reg_rule: {
      cmpP_reg_regNode *node = new (C) cmpP_reg_regNode();
      return node;
    }
  case cmpP_reg_imm16_rule: {
      cmpP_reg_imm16Node *node = new (C) cmpP_reg_imm16Node();
      return node;
    }
  case cmpF_reg_reg_Ex_rule: {
      cmpF_reg_reg_ExNode *node = new (C) cmpF_reg_reg_ExNode();
      return node;
    }
  case cmpF3_reg_reg_ExEx_rule: {
      cmpF3_reg_reg_ExExNode *node = new (C) cmpF3_reg_reg_ExExNode();
      return node;
    }
  case cmpD_reg_reg_Ex_rule: {
      cmpD_reg_reg_ExNode *node = new (C) cmpD_reg_reg_ExNode();
      return node;
    }
  case cmpD3_reg_reg_ExEx_rule: {
      cmpD3_reg_reg_ExExNode *node = new (C) cmpD3_reg_reg_ExExNode();
      return node;
    }
  case branch_rule: {
      branchNode *node = new (C) branchNode();
      node->set_opnd_array(1, MachOperGenerator(LABEL, C));
      return node;
    }
  case branchCon_rule: {
      branchConNode *node = new (C) branchConNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConFar_rule: {
      branchConFarNode *node = new (C) branchConFarNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConSched_rule: {
      branchConSchedNode *node = new (C) branchConSchedNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchLoopEnd_rule: {
      branchLoopEndNode *node = new (C) branchLoopEndNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchLoopEndFar_rule: {
      branchLoopEndFarNode *node = new (C) branchLoopEndFarNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchLoopEndSched_rule: {
      branchLoopEndSchedNode *node = new (C) branchLoopEndSchedNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case partialSubtypeCheck_rule: {
      partialSubtypeCheckNode *node = new (C) partialSubtypeCheckNode();
      node->set_opnd_array(3, MachOperGenerator(IREGPDST, C));
      node->set_opnd_array(4, MachOperGenerator(IREGPDST, C));
      node->set_opnd_array(5, MachOperGenerator(IREGPDST, C));
      return node;
    }
  case cmpFastLock_rule: {
      cmpFastLockNode *node = new (C) cmpFastLockNode();
      node->set_opnd_array(3, MachOperGenerator(IREGPDST, C));
      node->set_opnd_array(4, MachOperGenerator(IREGPDST, C));
      node->set_opnd_array(5, MachOperGenerator(IREGPDST, C));
      node->_counters = _leaf->as_FastLock()->counters();
      node->_rtm_counters = _leaf->as_FastLock()->rtm_counters();
      node->_stack_rtm_counters = _leaf->as_FastLock()->stack_rtm_counters();
      return node;
    }
  case cmpFastUnlock_rule: {
      cmpFastUnlockNode *node = new (C) cmpFastUnlockNode();
      node->set_opnd_array(3, MachOperGenerator(IREGPDST, C));
      node->set_opnd_array(4, MachOperGenerator(IREGPDST, C));
      node->set_opnd_array(5, MachOperGenerator(IREGPDST, C));
      return node;
    }
  case align_addr_rule: {
      align_addrNode *node = new (C) align_addrNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case array_size_rule: {
      array_sizeNode *node = new (C) array_sizeNode();
      return node;
    }
  case inlineCallClearArray_rule: {
      inlineCallClearArrayNode *node = new (C) inlineCallClearArrayNode();
      return node;
    }
  case string_indexOf_imm1_char_rule: {
      string_indexOf_imm1_charNode *node = new (C) string_indexOf_imm1_charNode();
      node->set_opnd_array(6, MachOperGenerator(IREGIDST, C));
      node->set_opnd_array(7, MachOperGenerator(IREGIDST, C));
      node->set_opnd_array(8, MachOperGenerator(IREGIDST, C));
      return node;
    }
  case string_indexOf_imm1_rule: {
      string_indexOf_imm1Node *node = new (C) string_indexOf_imm1Node();
      node->set_opnd_array(5, MachOperGenerator(IREGIDST, C));
      node->set_opnd_array(6, MachOperGenerator(IREGIDST, C));
      node->set_opnd_array(7, MachOperGenerator(IREGIDST, C));
      return node;
    }
  case string_indexOf_imm_rule: {
      string_indexOf_immNode *node = new (C) string_indexOf_immNode();
      node->set_opnd_array(5, MachOperGenerator(IREGIDST, C));
      node->set_opnd_array(6, MachOperGenerator(IREGIDST, C));
      node->set_opnd_array(7, MachOperGenerator(IREGIDST, C));
      node->set_opnd_array(8, MachOperGenerator(IREGIDST, C));
      node->set_opnd_array(9, MachOperGenerator(IREGIDST, C));
      node->set_opnd_array(10, MachOperGenerator(IREGIDST, C));
      return node;
    }
  case string_indexOf_rule: {
      string_indexOfNode *node = new (C) string_indexOfNode();
      node->set_opnd_array(5, MachOperGenerator(IREGIDST, C));
      node->set_opnd_array(6, MachOperGenerator(IREGLDST, C));
      node->set_opnd_array(7, MachOperGenerator(IREGLDST, C));
      node->set_opnd_array(8, MachOperGenerator(IREGLDST, C));
      node->set_opnd_array(9, MachOperGenerator(IREGLDST, C));
      return node;
    }
  case string_equals_imm_rule: {
      string_equals_immNode *node = new (C) string_equals_immNode();
      node->set_opnd_array(4, MachOperGenerator(IREGIDST, C));
      node->set_opnd_array(5, MachOperGenerator(IREGPDST, C));
      node->set_opnd_array(6, MachOperGenerator(IREGPDST, C));
      return node;
    }
  case string_equals_rule: {
      string_equalsNode *node = new (C) string_equalsNode();
      node->set_opnd_array(4, MachOperGenerator(IREGIDST, C));
      node->set_opnd_array(5, MachOperGenerator(IREGPDST, C));
      node->set_opnd_array(6, MachOperGenerator(IREGPDST, C));
      node->set_opnd_array(7, MachOperGenerator(IREGPDST, C));
      node->set_opnd_array(8, MachOperGenerator(IREGPDST, C));
      node->set_opnd_array(9, MachOperGenerator(IREGPDST, C));
      return node;
    }
  case string_compare_rule: {
      string_compareNode *node = new (C) string_compareNode();
      node->set_opnd_array(5, MachOperGenerator(IREGIDST, C));
      node->set_opnd_array(6, MachOperGenerator(IREGPDST, C));
      return node;
    }
  case minI_reg_reg_Ex_rule: {
      minI_reg_reg_ExNode *node = new (C) minI_reg_reg_ExNode();
      return node;
    }
  case maxI_reg_reg_Ex_rule: {
      maxI_reg_reg_ExNode *node = new (C) maxI_reg_reg_ExNode();
      return node;
    }
  case popCountI_rule: {
      popCountINode *node = new (C) popCountINode();
      return node;
    }
  case popCountL_rule: {
      popCountLNode *node = new (C) popCountLNode();
      return node;
    }
  case countLeadingZerosI_rule: {
      countLeadingZerosINode *node = new (C) countLeadingZerosINode();
      return node;
    }
  case countLeadingZerosL_rule: {
      countLeadingZerosLNode *node = new (C) countLeadingZerosLNode();
      return node;
    }
  case countTrailingZerosI_Ex_rule: {
      countTrailingZerosI_ExNode *node = new (C) countTrailingZerosI_ExNode();
      return node;
    }
  case countTrailingZerosL_Ex_rule: {
      countTrailingZerosL_ExNode *node = new (C) countTrailingZerosL_ExNode();
      return node;
    }
  case bytes_reverse_int_Ex_rule: {
      bytes_reverse_int_ExNode *node = new (C) bytes_reverse_int_ExNode();
      return node;
    }
  case repl8B_reg_Ex_rule: {
      repl8B_reg_ExNode *node = new (C) repl8B_reg_ExNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl8B_immI0_rule: {
      repl8B_immI0Node *node = new (C) repl8B_immI0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl8B_immIminus1_rule: {
      repl8B_immIminus1Node *node = new (C) repl8B_immIminus1Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl4S_reg_Ex_rule: {
      repl4S_reg_ExNode *node = new (C) repl4S_reg_ExNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl4S_immI0_rule: {
      repl4S_immI0Node *node = new (C) repl4S_immI0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl4S_immIminus1_rule: {
      repl4S_immIminus1Node *node = new (C) repl4S_immIminus1Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl2I_reg_Ex_rule: {
      repl2I_reg_ExNode *node = new (C) repl2I_reg_ExNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl2I_immI0_rule: {
      repl2I_immI0Node *node = new (C) repl2I_immI0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl2I_immIminus1_rule: {
      repl2I_immIminus1Node *node = new (C) repl2I_immIminus1Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl2F_reg_Ex_rule: {
      repl2F_reg_ExNode *node = new (C) repl2F_reg_ExNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl2F_immF_Ex_rule: {
      repl2F_immF_ExNode *node = new (C) repl2F_immF_ExNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl2F_immF0_rule: {
      repl2F_immF0Node *node = new (C) repl2F_immF0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case safePoint_poll_rule: {
      safePoint_pollNode *node = new (C) safePoint_pollNode();
      return node;
    }
  case safePoint_poll_conPollAddr_rule: {
      safePoint_poll_conPollAddrNode *node = new (C) safePoint_poll_conPollAddrNode();
      return node;
    }
  case CallStaticJavaDirect_rule: {
      CallStaticJavaDirectNode *node = new (C) CallStaticJavaDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallStaticJavaDirectHandle_rule: {
      CallStaticJavaDirectHandleNode *node = new (C) CallStaticJavaDirectHandleNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallDynamicJavaDirectSched_rule: {
      CallDynamicJavaDirectSchedNode *node = new (C) CallDynamicJavaDirectSchedNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallDynamicJavaDirectSched_Ex_rule: {
      CallDynamicJavaDirectSched_ExNode *node = new (C) CallDynamicJavaDirectSched_ExNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallDynamicJavaDirect_rule: {
      CallDynamicJavaDirectNode *node = new (C) CallDynamicJavaDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallRuntimeDirect_rule: {
      CallRuntimeDirectNode *node = new (C) CallRuntimeDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallLeafDirect_rule: {
      CallLeafDirectNode *node = new (C) CallLeafDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallLeafDirect_Ex_rule: {
      CallLeafDirect_ExNode *node = new (C) CallLeafDirect_ExNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallLeafNoFPDirect_Ex_rule: {
      CallLeafNoFPDirect_ExNode *node = new (C) CallLeafNoFPDirect_ExNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case TailCalljmpInd_rule: {
      TailCalljmpIndNode *node = new (C) TailCalljmpIndNode();
      return node;
    }
  case Ret_rule: {
      RetNode *node = new (C) RetNode();
      return node;
    }
  case tailjmpInd_rule: {
      tailjmpIndNode *node = new (C) tailjmpIndNode();
      return node;
    }
  case CreateException_rule: {
      CreateExceptionNode *node = new (C) CreateExceptionNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case RethrowException_rule: {
      RethrowExceptionNode *node = new (C) RethrowExceptionNode();
      return node;
    }
  case ShouldNotReachHere_rule: {
      ShouldNotReachHereNode *node = new (C) ShouldNotReachHereNode();
      return node;
    }
  case tlsLoadP_rule: {
      tlsLoadPNode *node = new (C) tlsLoadPNode();
      return node;
    }
  
  default:
    fprintf(stderr, "Default MachNode Generator invoked for: \n");
    fprintf(stderr, "   opcode = %d\n", opcode);
    break;
  };
  return NULL;
}
// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DPPC64=1
#ifndef PPC64
#  error "PPC64 must be defined"
#endif // PPC64
// Check adlc -D_LP64=1
#ifndef _LP64
#  error "_LP64 must be defined"
#endif // _LP64
